unit FensterGraf;                                        (* Version  14.12.00 *)

interface

uses
  WinTypes, Classes, Graphics, Controls,
  Forms, ExtCtrls, StdCtrls, ClipBrd, Dialogs, Menus;

const AnzFarben = 255;

var               (* hier werden die Codes der gedrckten Tasten gespeichert: *)
    KeyBuffer: TCaption;
    Color: array [0..AnzFarben] of TColor;
    InfoDatei: String;
    started: boolean;
    InfoBild: String;

type
  TGrundfenster = class(TForm)

    GrafikBMP: TImage;                                       (* Grafik-Bitmap *)
    Timer: TTimer;                                 (* zum Bildladen *)

                                                (* Reaktionen auf Ereignisse: *)
    procedure OnTimer(Sender: TObject);
                             (* wird in der Hauptschleife stndig aufgerufen! *)
    procedure OnCreate(Sender: TObject);
    procedure OnPaint(Sender: TObject);
    procedure OnDestroy(Sender: TObject);

    procedure OnMouseMove(Sender: TObject; Shift: TShiftState;
                          X, Y: Integer);
    procedure OnMouseDown(Sender: TObject; Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer);
    procedure OnMouseUp(Sender: TObject; Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer);
    procedure OnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure OnKeyPressed(Sender: TObject; var Key: Char);

                                               (* Reaktionen auf Menauswahl: *)

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var Grundfenster: TGrundfenster;
    xMaus, yMaus, MTasten: integer;
    vp: integer;

       var r: TRect;


procedure sichern;

procedure restaurieren;

procedure refresh;

procedure savePicture(Name: String; x1, y1, x2, y2: integer);

procedure loadPicture(Name: String; x0, y0: integer);

procedure zeigeTextdatei(Name: String; TGroesse: integer);

implementation

{$R *.DFM}
uses Kern;

var BildSName, BildLName: String;
    BildNr: integer;
    EingabeAbgeschlossen, Anfang, BMPInitialisiert, inBMP, inClpbrd,
    TextGezeigt: boolean;
    Bitmap: TBitmap;
    lInfoStr: string;

procedure sichern;

   var r: TRect;

   begin
(*   if inBMP then Clipboard.Assign(Grundfenster.GrafikBMP.Picture)*)
   if not inBMP then with Grundfenster do
      begin
      r:=bounds(0, 0, Clientwidth, Clientheight);
      GrafikBMP.Canvas.CopyRect(r, zCanvas, r);
      end;
   Clipboard.Assign(Grundfenster.GrafikBMP.Picture);
   inClpbrd:=true;
   end;

procedure restaurieren;

   var r: TRect;  n: String;  s: integer;

   begin
(*   if inBMP then Grundfenster.GrafikBMP.Picture.Assign(Clipboard)*)
   if not inClpbrd then Exit;
   Grundfenster.GrafikBMP.Picture.Assign(Clipboard);
n:=zCanvas.Font.Name; s:=zCanvas.Font.Size;  (* Warum ist das ntig? *)
   zCanvas:=Grundfenster.GrafikBMP.Canvas;
zCanvas.Font.Name:=n; zCanvas.Font.Size:=s;
   if not inBMP then with Grundfenster do
      begin
      r:=bounds(0, 0, Clientwidth, ClientHeight);
      Canvas.CopyRect(r, GrafikBMP.Canvas, r);
      end;
   end;

procedure refresh;

   begin
   if inBMP then Grundfenster.GrafikBMP.refresh
   end;

procedure savePicture(Name: String; x1, y1, x2, y2: integer);

   var bm: TBitmap;
       rs, rd: TRect;

   begin
   bm:=TBitmap.Create;
   bm.Monochrome:=not farbig;
   rs:=Rect(x1, y1, x2, y2);
   rd:=Bounds(0, 0, x2-x1, y2-y1);
   bm.Canvas.CopyRect(rd, zCanvas, rs);
   bm.SaveToFile(Name);
   bm.Free;
   end;

procedure loadPicture(Name: String; x0, y0: integer);

   var bm: TBitmap;

   begin
   if not DateiVorhanden(Name) then exit;
   bm:=TBitmap.Create;
   bm.loadFromFile(Name);
   if Name = InfoBild then
      begin
      x0:=(xm-bm.Width) div 2; y0:=(ym-bm.Height) div 2;
      end;
   zCanvas.Draw(x0, y0, bm);
   bm.Free
   end;

procedure initFarben;

   var i: integer;

   begin
   if not farbig
      then
         begin
         for i:=0 to 14 do FensterGraf.Color[i]:=clBlack;
         FensterGraf.Color[15]:=clWhite
         end
      else
         begin
         FensterGraf.Color[weiss]:=clWhite; FensterGraf.Color[schwarz]:=clBlack;
         FensterGraf.Color[blau]:=clBlue; FensterGraf.Color[gruen]:=clgreen;
         FensterGraf.Color[rot]:=clred; FensterGraf.Color[braun]:=clMaroon;
         FensterGraf.Color[hellblau]:=clAqua; FensterGraf.Color[hellgruen]:=clLime;
         FensterGraf.Color[grau]:=clGray; FensterGraf.Color[gelb]:=clYellow;
         FensterGraf.Color[hellmagenta]:=clFuchsia;
         FensterGraf.Color[magenta]:=clPurple; FensterGraf.Color[hellgrau]:=clSilver;
         FensterGraf.Color[cyan]:=clNavy; FensterGraf.Color[hellcyan]:=clOlive;
         FensterGraf.Color[hellrot]:=clTeal;
         end;
   end;
{
procedure informiereAlt;

   var s: TCaption;
       p: integer;
       st: String;

   begin
   if InfoStr='' then Exit;
   s:=InfoStr;
   with Grundfenster.Memo do
      begin
      left:=(Grundfenster.ClientWidth - Width) div 2;
       Top:=(Grundfenster.ClientHeight-Height) div 2;
      Text:='';
      p:=Pos('&', s);
      while p>0 do
         begin
         st:=Copy(s, 1, p-2);
         Lines.Add(st);
         Delete(s, 1, p+1);
         p:=Pos('&', s)
         end;
      Lines.Add(s);
      show
      end
   end;
}
var Bild: boolean = false;

(*********************** Reaktionen auf Ereignisse ****************************)

procedure TGrundfenster.OnTimer(Sender: TObject);

   var s: TCaption;

   begin
   if Fenstertitel=''
      then s:=Programmname
      else s:=Programmname+': '+Fenstertitel;
   if Caption<>s then Caption:=s;
   {$IFNDEF Graf}
   if Info1Str<>Panel2.Caption then
      begin
      Panel2.Caption:=Info1Str;
      end;
   if Info2Str<>Panel3.Caption then
      begin
      Panel3.Caption:=Info2Str;
      end;
   if Panel1.left<>0 then Panel1.Left:=0;
   {$ENDIF}
   if EingabeAbgeschlossen then Kern.Run;
   end;

procedure TGrundfenster.OnCreate(Sender: TObject);

   begin
   BildNr:=1;
   xmMax:=Screen.Width; ymMax:=Screen.Height;
   zCanvas:=Grundfenster.Canvas;
   zCanvas.Font:=Canvas.Font;
   zHoehe:=zCanvas.TextHeight('T');
   zBreite:=zCanvas.TextWidth('T');

   Caption:=Programmname;
   {$IFNDEF Graf}
   Panel1.Width:=ClientWidth;
   Panel1.Top:=ClientHeight-Panel1.Height;
   Panel1.Left:=0;
   Panel2.Width:=Panel1.Width div 2;
{   Memo.Cursor:=crNone;}
   HorzScrollbar.Range:=xmMax;
   VertScrollbar.Range:=ymMax;
   {$ENDIF}
   Kern.GotoXY(zBreite, zHoehe);
   initFarben;
   (*$IFDEF VER20*)
      HorzScrollbar.Tracking:=true;
      VertScrollbar.Tracking:=true;
   (*$ENDIF*)

{         inBMP:=true;
         if not BMPInitialisiert then with Grundfenster do
            begin
            Bitmap:=TBitmap.Create;
            Bitmap.Width:=xmMax;
            Bitmap.Height:=ymMax;
            Bitmap.Monochrome:=not farbig;
            Grundfenster.GrafikBMP.Picture.Graphic:=Bitmap;
            r:=bounds(0, 0, ClientWidth, ClientHeight);
            GrafikBMP.Canvas.CopyRect(r, Canvas, r);
            BMPInitialisiert:=true;
            end;
         Grundfenster.GrafikBMP.Show;
         zCanvas:=Grundfenster.GrafikBMP.Canvas;
         zCanvas.Font:=Grundfenster.Canvas.Font;
}
   end;

procedure TGrundfenster.OnPaint(Sender: TObject);

   begin
   {$IFNDEF Graf}
   if VertScrollbar.Position<>vp then
      begin
      Panel1.Top:=ClientHeight-Panel1.Height;
      Panel1.Left:=0;
      vp:=VertScrollbar.Position;
      end;
   if Anfang then
      begin
      VertScrollbar.Position:=0;
      end;
   {$ENDIF}
   IF Anfang then Anfang:=false;
(*   if Paintbox.Visible then informiere;*)
   restaurieren;
   end;

procedure TGrundfenster.OnDestroy(Sender: TObject);

   begin
   if BMPInitialisiert then GrafikBMP.Free
   end;

procedure TGrundfenster.OnMouseMove(Sender: TObject; Shift: TShiftState;
                                  X, Y: Integer);

   begin
   xMaus:=x; yMaus:=y;
   if (ssLeft in Shift) and (ssRight in Shift)
      then MTasten:=3
      else
         begin
         if ssLeft in Shift
          then MTasten:=1
          else
             if ssRight in Shift
                then MTasten:=2
                else MTasten:=0
         end;
   end;

procedure TGrundfenster.OnMouseDown(Sender: TObject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);

   begin
   xMaus:=x; yMaus:=y;
   if (ssLeft in Shift) and (ssRight in Shift)
      then MTasten:=3
      else
         begin
         if ssLeft in Shift
          then MTasten:=1
          else
             if ssRight in Shift
                then MTasten:=2
                else MTasten:=0
         end;
   if TextGezeigt then
      begin
      loescheBildschirm;
      TextGezeigt:=false;
      InfoStr:=lInfoStr
      end;
   end;

procedure TGrundfenster.OnMouseUp(Sender: TObject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);

   begin
   xMaus:=x; yMaus:=y;
   if (ssLeft in Shift) and (ssRight in Shift)
      then MTasten:=3
      else
         begin
         if ssLeft in Shift
          then MTasten:=1
          else
             if ssRight in Shift
                then MTasten:=2
                else MTasten:=0
         end;
   end;

procedure TGrundfenster.OnKeyDown(Sender: TObject;
                                  var Key: Word; Shift: TShiftState);
                                             (* Abfragen einiger Sondertasten *)

   var k, Taste: Word;

   begin
   k:=Key; Taste:=0;
   if (Shift=[ssCtrl]) and (Key=67) then Halt; (* Abbruch des Programmes mit CtrlC *)
   case k of
            33: Taste:=BildHoch;
            34: Taste:=BildRunter;
            36: Taste:=Pos1;
            45: Taste:=Einfg;
            46: Taste:=Entf;
            35: Taste:=Kern.Ende;
            37: Taste:=CursorLinks;
            38: Taste:=CursorHoch;
            39: Taste:=CursorRechts;
            40: Taste:=CursorRunter;
      112..123: if Shift=[] then Taste:=k-112+F1 else if Shift=[ssShift] then Taste:=k-112+F1+27
     end;
   if Taste>0 then
      if Length(KeyBuffer)<255 then KeyBuffer:=KeyBuffer+Chr(Taste);
   end;

procedure TGrundfenster.OnKeyPressed(Sender: TObject; var Key: Char);
                                                 (* Abfragen der ASCII-Tasten *)

   begin
   if Key=#13 then Key:=Chr(Return);
   if Length(KeyBuffer)<255 then KeyBuffer:=KeyBuffer+Key;
   if TextGezeigt then
      begin
      loescheBildschirm;
      TextGezeigt:=false;
      InfoStr:=lInfoStr;
      end;
   end;

(*********************** Reaktionen auf Menauswahl: **************************)

procedure setzeSchriftgroesse(gr: integer);

   begin
   with zCanvas do
      begin
(*      if not FontgroesseGeaendert then normalSchriftgroesse:=Font.Size;
      FontgroesseGeaendert:=true;*)
      Font.Size:=gr;
      zHoehe:=TextHeight('T');
      zBreite:=TextWidth('T');
      end;
   end;

procedure zeigeTextdatei(Name: String; TGroesse: integer);

   var t: TextFile;
       s, fName: string;
       size: integer;

   begin
   lInfoStr:=InfoStr;
   InfoStr:='';
   if not DateiVorhanden(Name) then Exit;
   size:=zCanvas.Font.Size;
   AssignFile(t, Name); Reset(t);
   setzeFuelltyp(255, weiss, weiss);
   fuelleRechteck(0, 0, xm, ym);
   fName:=zCanvas.Font.Name;
   zCanvas.Font.Name:='Courier'; (* nicht proportional! *)
   setzeTextausrichtung(0,0);
   setzeSchriftgroesse(tGroesse);
   WriteLn('');
   while not eof(t) do
      begin
      ReadLn(t, s);
      WriteLn(s);
      end;
   CloseFile(t);
   zCanvas.Font.Name:=fName;
   zCanvas.Font.Size:=size;
   TextGezeigt:=true;
   end;

Initialization

Anfang:=true;
EingabeAbgeschlossen:=true;
Start:=dummyProzedur;
Run:=dummyProzedur;
inBMP:=false; BMPInitialisiert:=false;
inClpbrd:=false;
KeyBuffer:='';
BildSName:=Programmname; BildLName:='';

InfoDatei:=ParamStr(0);                  (* Voreinstellung fr Infodatei! *)
Delete(InfoDatei, Length(InfoDatei)-2, 3);
InfoBild:=InfoDatei;
InfoDatei:=InfoDatei+'txt';

started:=false;

TextGezeigt:=false;
InfoBild:=InfoBild+'bmp';
end.
