unit GraphCrt;

interface

uses SysUtils, Kern;

const backspace = 8;

var bEingabe: boolean = false;

procedure setzeTextmodus;

procedure GotoXY(x, y: integer);

procedure setzeGrafikmodus;

procedure loescheBildschirm;

procedure zeichneCursor(f: integer);

procedure Write(s: String);

procedure WriteLn(s: String);

procedure schreibeTaste(var Taste: integer);

procedure liesChar(s0: String; var c: Char; var cEingegeben: boolean);

procedure liesString(s0: String; var s: String; var b: boolean);

procedure liesInteger(s:String; var IntS: String; var intEingegeben: boolean;
                      var i:integer);

procedure liesReal(s: String; var Rs: String; var rEingegeben: boolean;
                   var r:real);

implementation

var pEingabestring: ^String;
    pEingabezeichen: ^Char;
    pEingabebeendet: ^boolean;
    CurmaxX, CurmaxY, CurX0, CurY0, CurX, CurY, StringPosition: integer;
    Textfarbe, TextHFarbe, CursorFarbe: integer;
    Textmodus: boolean = true;
    rEingabe: boolean = false;
    iEingabe: boolean = false;
    cEingabe: boolean = false;
    pi: ^integer;
    pr: ^real;

procedure setzeTextmodus;

   begin
   setzeTextHFarbe(schwarz);
   TextHFarbe:=schwarz;
   TextFarbe:=weiss;
   setzeFuelltyp(0, schwarz, schwarz);
   fuelleRechteck(0, 0, xm, ym);
   CurX:=1; CurY:=1;
   CursorFarbe:=TextHFarbe;
   versteckeMaus;
   Textmodus:=true;
   CurmaxX:=xm div zBreite; CurmaxY:=ym div zHoehe;
   end;

procedure GotoXY(x, y: integer);

   begin
   if x>CurmaxX then CurX:=CurmaxX else CurX:=x;
   if y>CurmaxY then CurY:=CurmaxY else CurY:=y
   end;

procedure setzeGrafikmodus;

   begin
   setzeTextHFarbe(weiss);
   TextHFarbe:=weiss;
   TextFarbe:=schwarz;
   setzeFuelltyp(255, weiss, weiss);
   fuelleRechteck(0, 0, xm, ym);
   zeigeMaus;
   Textmodus:=false;
   end;

procedure loescheBildschirm;

   begin
   if Textmodus
      then setzeFuelltyp(0, weiss, schwarz)
      else setzeFuelltyp(255, weiss, weiss);
   fuelleRechteck(0, 0, xm, ym)
   end;

procedure zeichneCursor(f: integer);

   begin
   if not Textmodus then Exit;
   zeichneLinie((CurX-1)*zBreite, CurY*zHoehe-1, (CurX-1)*zBreite+zBreite, CurY*zHoehe-1, f);
   zeichneLinie((CurX-1)*zBreite, CurY*zHoehe-2, (CurX-1)*zBreite+zBreite, CurY*zHoehe-2, f);
   end;

procedure WriteC(c: Char);

   begin
   if not Textmodus then Exit;
   zeichneCursor(TextHFarbe);
   zeichneGrafstring((CurX-1)*zBreite, CurY*zHoehe, c, Textfarbe);
   if CurX<CurmaxX
      then Inc(CurX)
      else
         begin
         CurX:=1; Inc(CurY)
         end;
   zeichneCursor(CursorFarbe);
   end;

procedure Write(s: String);

   var i: integer;

   begin
   if not Textmodus then Exit;
   zeichneCursor(TextHFarbe);
   for i:=1 to Length(s) do WriteC(s[i]);
   zeichneCursor(CursorFarbe);
   end;

procedure WriteLn(s: String);

   begin
   if not Textmodus then Exit;
   Write(s);
   zeichneCursor(TextHFarbe);
   CurX:=1; Inc(CurY);
   zeichneCursor(CursorFarbe);
   end;

procedure schreibeTaste(var Taste: integer);

   var Code, p: integer;
       ok: boolean;
       s1: String;

   begin
   if not Textmodus then Exit;
   Taste:=0; ok:=true;
   if TasteGedrueckt then Taste:=Tastencode;
   if Taste>0 then
      case Taste of
         Return:
            begin
            if iEingabe then
               begin
               wandleStringInInteger(pEingabestring^, pi^, Code);
               if Code<>0
                  then
                     begin
                     Beep;
                     ok:=false
                     end
                  else
                     iEingabe:=false;
               end;
            if rEingabe then
               begin
               s1:=pEingabestring^;
               p:=Pos(',',s1);
               while p>0 do
                  begin
                  s1[p]:='.';
                  p:=Pos(',',s1);
                  end;
               wandleStringInReal(s1, pr^, Code);
               if Code<>0
                  then
                     begin
                     Beep;
                     ok:=false
                     end
                  else
                     rEingabe:=false;
               end;
            if ok then
               begin
               WriteLn('');
               Cursorfarbe:=TextHFarbe;
               zeichneCursor(CursorFarbe);
               BEingabe:=false; pEingabebeendet^:=true;
               if cEingabe
                  then zeichneGrafstring((CurX0-1)*zBreite, CurY0*zHoehe, pEingabezeichen^, hellrot)
                  else zeichneGrafstring((CurX0-1)*zBreite, CurY0*zHoehe, pEingabestring^, hellrot);
               cEingabe:=false;
               TextFarbe:=weiss;
               end;
            end;
         backspace: if CurX>CurX0 then begin
               zeichneCursor(TextHFarbe);
               Dec(CurX);
               zeichneGrafstring((CurX-1)*zBreite, CurY*zHoehe, ' ', TextFarbe);
               zeichneCursor(Textfarbe);
               Delete(pEingabestring^, length(pEingabestring^), 1);
               Dec(Stringposition);
               end;
         CursorLinks: if CurX>CurX0 then begin
               zeichneCursor(TextHFarbe);
               Dec(CurX);
               zeichneCursor(Textfarbe);
               Dec(Stringposition);
               end;
         CursorRechts: if Stringposition<Length(pEingabestring^)+1 then begin
               zeichneCursor(TextHFarbe);
               Inc(CurX);
               zeichneCursor(Textfarbe);
               Inc(Stringposition);
               end;
         Esc: begin
              zeichneCursor(TextHFarbe);
              CurX:=CurX0;
              zeichneGrafstring((CurX-1)*zBreite, CurY*zHoehe, pEingabestring^, TextHFarbe);
              pEingabestring^:='';
              zeichneCursor(Textfarbe);
              Stringposition:=1;
              end;
         else begin
              Write(Chr(Taste));
              if cEingabe
                 then
                    begin
                    Cursorfarbe:=TextHFarbe;
                    zeichneCursor(CursorFarbe);
                    BEingabe:=false; pEingabebeendet^:=true;
                    pEingabezeichen^:=Chr(Taste);
                    zeichneGrafstring((CurX0-1)*zBreite, CurY0*zHoehe, pEingabezeichen^, hellrot);
                    WriteLn('');
                    cEingabe:=false;
                    TextFarbe:=weiss;
                    end
                 else
                    begin
                    if Stringposition=Length(pEingabestring^)+1
                       then pEingabestring^:=pEingabestring^+Chr(Taste)
                       else pEingabestring^[Stringposition]:=Chr(Taste);
                    Inc(Stringposition);
                    end;
              end;
         end
   end;

procedure liesChar(s0: String; var c: Char; var cEingegeben: boolean);

    begin
    if not Textmodus then Exit;
    if bEingabe or cEingegeben then Exit;
    Write(s0);
    CurX0:=CurX; CurY0:=CurY;
    BEingabe:=true; cEingegeben:=false; pEingabebeendet:=@cEingegeben;
    Textfarbe:=gelb;
    CursorFarbe:=TextFarbe;
    zeichneGrafstring((CurX-1)*zBreite, CurY*zHoehe, c, TextFarbe);
    zeichneCursor(CursorFarbe);
    pEingabezeichen:=@c;
    cEingabe:=true;
    end;

procedure liesString(s0: String; var s: String; var b: boolean);

    begin
    if not Textmodus then Exit;
    Write(s0);
    CurX0:=CurX; CurY0:=CurY;
    BEingabe:=true; b:=false; pEingabebeendet:=@b;
    Textfarbe:=gelb;
    CursorFarbe:=TextFarbe;
    Write(s);
    pEingabestring:=@s;
    StringPosition:=Length(s)+1;
    end;

procedure liesInteger(s:String; var IntS: String; var intEingegeben: boolean;
                      var i:integer);

   begin
   if not Textmodus then Exit;
   if bEingabe or intEingegeben then Exit;
   iEingabe:=true;
   intEingegeben:=false;
   pEingabebeendet:=@intEingegeben;
   pi:=@i;
   liesString(s, IntS, intEingegeben);
   end;

procedure liesReal(s: String; var Rs: String; var rEingegeben: boolean;
                   var r:real);

   begin
   if not Textmodus then Exit;
   if bEingabe or rEingegeben then Exit;
   rEingabe:=true;
   rEingegeben:=false;
   pEingabebeendet:=@rEingegeben;
   pr:=@r;
   liesString(s, Rs, rEingegeben);
   end;

begin
Textmodus:=true
end.
