{2:}unit Mathe;{Version 0.13 vom 8.10.1997}interface (*uses Kern;{4:}*)
const ZweiPi=2.0*Pi;HPi=0.5*Pi;Grad=Pi/180.0;Sec=Grad/3600.0;{:4}{5:}
function tan(x:real):real;
function arcsin(x:real):real;function arccos(x:real):real;
function atn2(y,x:real):real;{:6}{7:}type RVektor=array[0..3]of real;
PVektor=record r,Laenge,Breite:real end;Matrix=array[1..3,1..3]of real;
{:7}{8:}procedure definiereRVektor(r1,r2,r3:real;var r:RVektor);{:8}{9:}
procedure normiereRVektor(var r:RVektor);{:9}{10:}
procedure addiereRVektoren(r1,r2:RVektor;var r:RVektor);{:10}{11:}
procedure subtrahiereRVektoren(r1,r2:RVektor;var r:RVektor);{:11}{12:}
procedure multipliziereRVektor(Faktor:real;var r:RVektor);{:12}{13:}
procedure berechneKreuzprodukt(r1,r2:RVektor;var r:RVektor);{:13}{14:}
function Skalarprodukt(r1,r2:RVektor):real;{:14}{15:}
procedure berechneCartK(p:PVektor;var r:RVektor);
procedure berechnePolarK(r:RVektor;var p:PVektor);{:15}{16:}
procedure dreheRVektor(var D:Matrix;var r:RVektor);
procedure definiereXDrehung(w:real;var D:Matrix);
procedure definiereYDrehung(w:real;var D:Matrix);
procedure definiereZDrehung(w:real;var D:Matrix);{:16}{17:}
procedure multipliziereMatrizen(var D1,D2,D:Matrix);{:17}{18:}
type Funktion=function(var t:real):real;
function Nullstelle(f,f1:Funktion;Anfang,Genauigkeit:real;
maxIter:integer):real;{:18}implementation{20:}function tan(x:real):real;
var r:real;begin r:=cos(x);
if Abs(r)<1E-7 then begin if r<0.0 then tan:=-1.0E7 else tan:=1.0E7 end
else tan:=sin(x)/cos(x)end;function arcsin(x:real):real;
const eps=1.0E-7;
begin if Abs(x)=1.0 then arcsin:=0.5*Pi*x else if Abs(x)>eps then arcsin
:=arctan(x/sqrt(1.0-x*x))else arcsin:=x end;
function arccos(x:real):real;
begin if x>0.0 then arccos:=arctan(sqrt(1.0/sqr(x)-1.0))else if x<0.0
then arccos:=-arctan(sqrt(1.0/sqr(x)-1.0))+Pi else arccos:=HPi end;
function atn2(y,x:real):real;var ax,ay,phi:real;
begin if(x=0.0)and(y=0.0)then atn2:=0.0 else begin ax:=Abs(x);
ay:=Abs(y);if(ax>ay)then phi:=arctan(ay/ax)else phi:=HPi-arctan(ax/ay);
if(x<0.0)then phi:=Pi-phi;if(y<0.0)then phi:=-phi;atn2:=phi;end end;
{:20}{21:}procedure definiereRVektor(r1,r2,r3:real;var r:RVektor);
begin r[1]:=r1;r[2]:=r2;r[3]:=r3;r[0]:=sqrt(r1*r1+r2*r2+r3*r3);end;
procedure normiereRVektor(var r:RVektor);var i:integer;
begin if r[0]>0.0 then for i:=1 to 3 do r[i]:=r[i]/r[0];r[0]:=1.0 end;
procedure addiereRVektoren(r1,r2:RVektor;var r:RVektor);var i:integer;
begin for i:=1 to 3 do r[i]:=r1[i]+r2[i];
r[0]:=sqrt(r[1]*r[1]+r[2]*r[2]+r[3]*r[3])end;
procedure subtrahiereRVektoren(r1,r2:RVektor;var r:RVektor);
var i:integer;begin for i:=1 to 3 do r[i]:=r1[i]-r2[i];
r[0]:=sqrt(r[1]*r[1]+r[2]*r[2]+r[3]*r[3])end;
procedure multipliziereRVektor(Faktor:real;var r:RVektor);var i:integer;
begin for i:=0 to 3 do r[i]:=Faktor*r[i];r[0]:=Abs(r[0])end;
procedure berechneKreuzprodukt(r1,r2:RVektor;var r:RVektor);
begin r[1]:=r1[2]*r2[3]-r1[3]*r2[2];
r[2]:=r1[3]*r2[1]-r1[1]*r2[3];r[3]:=r1[1]*r2[2]-r1[2]*r2[1];
r[0]:=sqrt(r[1]*r[1]+r[2]*r[2]+r[3]*r[3])end;
function Skalarprodukt(r1,r2:RVektor):real;
begin Skalarprodukt:=r1[1]*r2[1]+r1[2]*r2[2]+r1[3]*r2[3]end;
procedure berechneCartK(p:PVektor;var r:RVektor);var rcst:real;
begin rcst:=p.r*cos(p.Breite);r[1]:=rcst*cos(p.Laenge);
r[2]:=rcst*sin(p.Laenge);r[3]:=p.r*sin(p.Breite);r[0]:=p.r end;
procedure berechnePolarK(r:RVektor;var p:PVektor);begin p.r:=r[0];
p.Breite:=arctan(r[3]/sqrt(r[1]*r[1]+r[2]*r[2]));
p.Laenge:=atn2(r[2],r[1]);
if p.Laenge<0.0 then p.Laenge:=p.Laenge+ZweiPi;end;
procedure dreheRVektor(var D:Matrix;var r:RVektor);var i,j:integer;
rn:RVektor;begin for j:=1 to 3 do begin rn[j]:=0.0;
for i:=1 to 3 do rn[j]:=rn[j]+D[j,i]*r[i]end;
definiereRVektor(rn[1],rn[2],rn[3],r);end;
procedure definiereXDrehung(w:real;var D:Matrix);var i,j:integer;
sinw,cosw:real;begin sinw:=sin(w);cosw:=cos(w);
for j:=1 to 3 do for i:=1 to 3 do D[i,j]:=0.0;D[1,1]:=1.0;D[2,2]:=cosw;
D[2,3]:=-sinw;D[3,2]:=sinw;D[3,3]:=cosw;end;
procedure definiereYDrehung(w:real;var D:Matrix);var i,j:integer;
sinw,cosw:real;begin sinw:=sin(w);cosw:=cos(w);
for j:=1 to 3 do for i:=1 to 3 do D[i,j]:=0.0;D[2,2]:=1.0;D[1,1]:=cosw;
D[1,3]:=sinw;D[3,1]:=-sinw;D[3,3]:=cosw;end;
procedure definiereZDrehung(w:real;var D:Matrix);var i,j:integer;
sinw,cosw:real;begin sinw:=sin(w);cosw:=cos(w);
for j:=1 to 3 do for i:=1 to 3 do D[i,j]:=0.0;D[3,3]:=1.0;D[1,1]:=cosw;
D[1,2]:=-sinw;D[2,1]:=sinw;D[2,2]:=cosw;end;
procedure multipliziereMatrizen(var D1,D2,D:Matrix);var i,j,k:integer;
Dn:Matrix;begin for i:=1 to 3 do for j:=1 to 3 do begin Dn[i,j]:=0.0;
for k:=1 to 3 do Dn[i,j]:=Dn[i,j]+D1[i,k]*D2[k,j];end;D:=Dn end;{:21}
{22:}function Nullstelle(f,f1:Funktion;Anfang,Genauigkeit:real;
maxIter:integer):real;var x0,x1:real;i:integer;begin x0:=Anfang;i:=0;
x1:=x0-f(x0)/f1(x0);
while(Abs(x0-x1)>Genauigkeit)and(i<maxIter)do begin Inc(i);x0:=x1;
x1:=x0-f(x0)/f1(x0)end;Nullstelle:=x1 end;{:22}begin end.
